diff --git a/syntax/error.rs b/syntax/error.rs
index 103a54f..f52d651 100644
--- a/syntax/error.rs
+++ b/syntax/error.rs
@@ -15,7 +15,6 @@ impl Display for Error {
 
 pub static ERRORS: &[Error] = &[
     BOX_CXX_TYPE,
-    VEC_CXX_TYPE,
     CXXBRIDGE_RESERVED,
     CXX_STRING_BY_VALUE,
     CXX_TYPE_BY_VALUE,
@@ -30,12 +29,6 @@ pub static BOX_CXX_TYPE: Error = Error {
     note: Some("hint: use UniquePtr<>"),
 };
 
-pub static VEC_CXX_TYPE: Error = Error {
-    msg: "Vec of a C++ type is not supported yet",
-    label: None,
-    note: Some("hint: use UniquePtr<>"),
-};
-
 pub static CXXBRIDGE_RESERVED: Error = Error {
     msg: "identifiers starting with cxxbridge are reserved",
     label: Some("reserved identifier"),
diff --git a/syntax/impls.rs b/syntax/impls.rs
index 8e94f06..c34e3e5 100644
--- a/syntax/impls.rs
+++ b/syntax/impls.rs
@@ -27,7 +27,7 @@ impl Hash for Type {
             Type::Ref(t) => t.hash(state),
             Type::Str(t) => t.hash(state),
             Type::RustVec(t) => t.hash(state),
-            Type::Vector(t) => t.hash(state),
+            Type::CxxVector(t) => t.hash(state),
             Type::Fn(t) => t.hash(state),
             Type::Slice(t) => t.hash(state),
             Type::SliceRefU8(t) => t.hash(state),
@@ -47,7 +47,7 @@ impl PartialEq for Type {
             (Type::Ref(lhs), Type::Ref(rhs)) => lhs == rhs,
             (Type::Str(lhs), Type::Str(rhs)) => lhs == rhs,
             (Type::RustVec(lhs), Type::RustVec(rhs)) => lhs == rhs,
-            (Type::Vector(lhs), Type::Vector(rhs)) => lhs == rhs,
+            (Type::CxxVector(lhs), Type::CxxVector(rhs)) => lhs == rhs,
             (Type::Fn(lhs), Type::Fn(rhs)) => lhs == rhs,
             (Type::Slice(lhs), Type::Slice(rhs)) => lhs == rhs,
             (Type::SliceRefU8(lhs), Type::SliceRefU8(rhs)) => lhs == rhs,
diff --git a/syntax/mod.rs b/syntax/mod.rs
index 4e0b908..a4b0ac4 100644
--- a/syntax/mod.rs
+++ b/syntax/mod.rs
@@ -8,13 +8,11 @@ pub mod error;
 pub mod ident;
 mod impls;
 pub mod mangle;
-pub mod mangled;
 pub mod namespace;
 mod parse;
 pub mod set;
 pub mod symbol;
 mod tokens;
-pub mod typename;
 pub mod types;
 
 use self::parse::kw;
@@ -92,7 +90,7 @@ pub enum Type {
     UniquePtr(Box<Ty1>),
     Ref(Box<Ref>),
     Str(Box<Ref>),
-    Vector(Box<Ty1>),
+    CxxVector(Box<Ty1>),
     Fn(Box<Signature>),
     Void(Span),
     Slice(Box<Slice>),
diff --git a/syntax/namespace.rs b/syntax/namespace.rs
index a4e972b..d26bb9e 100644
--- a/syntax/namespace.rs
+++ b/syntax/namespace.rs
@@ -11,7 +11,7 @@ mod kw {
 
 #[derive(Clone)]
 pub struct Namespace {
-    pub segments: Vec<String>,
+    segments: Vec<String>,
 }
 
 impl Namespace {
diff --git a/syntax/parse.rs b/syntax/parse.rs
index f5c598d..d14806d 100644
--- a/syntax/parse.rs
+++ b/syntax/parse.rs
@@ -300,10 +300,10 @@ fn parse_type_path(ty: &TypePath) -> Result<Type> {
                             rangle: generic.gt_token,
                         })));
                     }
-                } else if ident == "Vector" && generic.args.len() == 1 {
+                } else if ident == "CxxVector" && generic.args.len() == 1 {
                     if let GenericArgument::Type(arg) = &generic.args[0] {
                         let inner = parse_type(arg)?;
-                        return Ok(Type::Vector(Box::new(Ty1 {
+                        return Ok(Type::CxxVector(Box::new(Ty1 {
                             name: ident,
                             langle: generic.lt_token,
                             inner,
diff --git a/syntax/tokens.rs b/syntax/tokens.rs
index 3d67a0a..13cbfcf 100644
--- a/syntax/tokens.rs
+++ b/syntax/tokens.rs
@@ -14,7 +14,7 @@ impl ToTokens for Type {
                 }
                 ident.to_tokens(tokens);
             }
-            Type::RustBox(ty) | Type::UniquePtr(ty) | Type::Vector(ty) | Type::RustVec(ty) => {
+            Type::RustBox(ty) | Type::UniquePtr(ty) | Type::CxxVector(ty) | Type::RustVec(ty) => {
                 ty.to_tokens(tokens)
             }
             Type::Ref(r) | Type::Str(r) | Type::SliceRefU8(r) => r.to_tokens(tokens),
@@ -35,10 +35,12 @@ impl ToTokens for Var {
 
 impl ToTokens for Ty1 {
     fn to_tokens(&self, tokens: &mut TokenStream) {
-        // Do not add cxx namespace to Vector since we're defining it in the user crate
-        if self.name == "UniquePtr" || self.name == "RustVec" {
-            let span = self.name.span();
+        let span = self.name.span();
+        let name = self.name.to_string();
+        if let "UniquePtr" | "CxxVector" = name.as_str() {
             tokens.extend(quote_spanned!(span=> ::cxx::));
+        } else if name == "Vec" {
+            tokens.extend(quote_spanned!(span=> ::std::vec::));
         }
         self.name.to_tokens(tokens);
         self.langle.to_tokens(tokens);
diff --git a/syntax/types.rs b/syntax/types.rs
index 7bce154..f3aaa16 100644
--- a/syntax/types.rs
+++ b/syntax/types.rs
@@ -24,9 +24,10 @@ impl<'a> Types<'a> {
             all.insert(ty);
             match ty {
                 Type::Ident(_) | Type::Str(_) | Type::Void(_) | Type::SliceRefU8(_) => {}
-                Type::RustBox(ty) | Type::UniquePtr(ty) | Type::Vector(ty) | Type::RustVec(ty) => {
-                    visit(all, &ty.inner)
-                }
+                Type::RustBox(ty)
+                | Type::UniquePtr(ty)
+                | Type::CxxVector(ty)
+                | Type::RustVec(ty) => visit(all, &ty.inner),
                 Type::Ref(r) => visit(all, &r.inner),
                 Type::Slice(s) => visit(all, &s.inner),
                 Type::Fn(f) => {
@@ -95,6 +96,7 @@ impl<'a> Types<'a> {
                     Atom::from(ident) == Some(RustString)
                 }
             }
+            Type::RustVec(_) => true,
             _ => false,
         }
     }
diff --git a/tests/ffi/lib.rs b/tests/ffi/lib.rs
index da0040a..d2c860e 100644
--- a/tests/ffi/lib.rs
+++ b/tests/ffi/lib.rs
@@ -27,9 +27,13 @@ pub mod ffi {
         fn c_return_sliceu8(shared: &Shared) -> &[u8];
         fn c_return_rust_string() -> String;
         fn c_return_unique_ptr_string() -> UniquePtr<CxxString>;
-        fn c_return_unique_ptr_vector_u8() -> UniquePtr<Vector<u8>>;
-        fn c_return_unique_ptr_vector_f64() -> UniquePtr<Vector<f64>>;
-        fn c_return_unique_ptr_vector_shared() -> UniquePtr<Vector<Shared>>;
+        fn c_return_unique_ptr_vector_u8() -> UniquePtr<CxxVector<u8>>;
+        fn c_return_unique_ptr_vector_f64() -> UniquePtr<CxxVector<f64>>;
+        fn c_return_unique_ptr_vector_shared() -> UniquePtr<CxxVector<Shared>>;
+        fn c_return_unique_ptr_vector_opaque() -> UniquePtr<CxxVector<C>>;
+        fn c_return_ref_vector(c: &C) -> &CxxVector<u8>;
+        fn c_return_rust_vec() -> Vec<u8>;
+        fn c_return_ref_rust_vec(c: &C) -> &Vec<u8>;
 
         fn c_take_primitive(n: usize);
         fn c_take_shared(shared: Shared);
@@ -41,11 +45,13 @@ pub mod ffi {
         fn c_take_sliceu8(s: &[u8]);
         fn c_take_rust_string(s: String);
         fn c_take_unique_ptr_string(s: UniquePtr<CxxString>);
-        fn c_take_unique_ptr_vector_u8(s: UniquePtr<Vector<u8>>);
-        fn c_take_unique_ptr_vector_f64(s: UniquePtr<Vector<f64>>);
-        fn c_take_unique_ptr_vector_shared(s: UniquePtr<Vector<Shared>>);
-        fn c_take_vec_u8(v: &Vec<u8>);
-        fn c_take_vec_shared(v: &Vec<Shared>);
+        fn c_take_unique_ptr_vector_u8(v: UniquePtr<CxxVector<u8>>);
+        fn c_take_unique_ptr_vector_f64(v: UniquePtr<CxxVector<f64>>);
+        fn c_take_unique_ptr_vector_shared(v: UniquePtr<CxxVector<Shared>>);
+        fn c_take_ref_vector(v: &CxxVector<u8>);
+        fn c_take_rust_vec(v: Vec<u8>);
+        fn c_take_rust_vec_shared(v: Vec<Shared>);
+        fn c_take_ref_rust_vec(v: &Vec<u8>);
         fn c_take_callback(callback: fn(String) -> usize);
 
         fn c_try_return_void() -> Result<()>;
@@ -57,6 +63,8 @@ pub mod ffi {
         fn c_try_return_sliceu8(s: &[u8]) -> Result<&[u8]>;
         fn c_try_return_rust_string() -> Result<String>;
         fn c_try_return_unique_ptr_string() -> Result<UniquePtr<CxxString>>;
+        fn c_try_return_rust_vec() -> Result<Vec<u8>>;
+        fn c_try_return_ref_rust_vec(c: &C) -> Result<&Vec<u8>>;
 
         fn get(self: &C) -> usize;
         fn set(self: &mut C, n: usize) -> usize;
@@ -76,6 +84,8 @@ pub mod ffi {
         fn r_return_str(shared: &Shared) -> &str;
         fn r_return_rust_string() -> String;
         fn r_return_unique_ptr_string() -> UniquePtr<CxxString>;
+        fn r_return_rust_vec() -> Vec<u8>;
+        fn r_return_ref_rust_vec(shared: &Shared) -> &Vec<u8>;
 
         fn r_take_primitive(n: usize);
         fn r_take_shared(shared: Shared);
@@ -87,6 +97,8 @@ pub mod ffi {
         fn r_take_sliceu8(s: &[u8]);
         fn r_take_rust_string(s: String);
         fn r_take_unique_ptr_string(s: UniquePtr<CxxString>);
+        fn r_take_rust_vec(v: Vec<u8>);
+        fn r_take_ref_rust_vec(v: &Vec<u8>);
 
         fn r_try_return_void() -> Result<()>;
         fn r_try_return_primitive() -> Result<usize>;
@@ -163,6 +175,15 @@ fn r_return_unique_ptr_string() -> UniquePtr<CxxString> {
     unsafe { UniquePtr::from_raw(cxx_test_suite_get_unique_ptr_string()) }
 }
 
+fn r_return_rust_vec() -> Vec<u8> {
+    Vec::new()
+}
+
+fn r_return_ref_rust_vec(shared: &ffi::Shared) -> &Vec<u8> {
+    let _ = shared;
+    unimplemented!()
+}
+
 fn r_take_primitive(n: usize) {
     assert_eq!(n, 2020);
 }
@@ -204,6 +225,14 @@ fn r_take_unique_ptr_string(s: UniquePtr<CxxString>) {
     assert_eq!(s.as_ref().unwrap().to_str().unwrap(), "2020");
 }
 
+fn r_take_rust_vec(v: Vec<u8>) {
+    let _ = v;
+}
+
+fn r_take_ref_rust_vec(v: &Vec<u8>) {
+    let _ = v;
+}
+
 fn r_try_return_void() -> Result<(), Error> {
     Ok(())
 }
diff --git a/tests/ffi/tests.cc b/tests/ffi/tests.cc
index a8d7018..c0b5888 100644
--- a/tests/ffi/tests.cc
+++ b/tests/ffi/tests.cc
@@ -28,6 +28,8 @@ size_t C::set2(size_t n) {
   return this->n;
 }
 
+const std::vector<uint8_t> &C::get_v() const { return this->v; }
+
 size_t c_return_primitive() { return 2020; }
 
 Shared c_return_shared() { return Shared{2020}; }
@@ -59,29 +61,45 @@ std::unique_ptr<std::string> c_return_unique_ptr_string() {
 }
 
 std::unique_ptr<std::vector<uint8_t>> c_return_unique_ptr_vector_u8() {
-  auto retval =
-      std::unique_ptr<std::vector<uint8_t>>(new std::vector<uint8_t>());
-  retval->push_back(86);
-  retval->push_back(75);
-  retval->push_back(30);
-  retval->push_back(9);
-  return retval;
+  auto vec = std::unique_ptr<std::vector<uint8_t>>(new std::vector<uint8_t>());
+  vec->push_back(86);
+  vec->push_back(75);
+  vec->push_back(30);
+  vec->push_back(9);
+  return vec;
 }
 
 std::unique_ptr<std::vector<double>> c_return_unique_ptr_vector_f64() {
-  auto retval = std::unique_ptr<std::vector<double>>(new std::vector<double>());
-  retval->push_back(86.0);
-  retval->push_back(75.0);
-  retval->push_back(30.0);
-  retval->push_back(9.5);
-  return retval;
+  auto vec = std::unique_ptr<std::vector<double>>(new std::vector<double>());
+  vec->push_back(86.0);
+  vec->push_back(75.0);
+  vec->push_back(30.0);
+  vec->push_back(9.5);
+  return vec;
 }
 
 std::unique_ptr<std::vector<Shared>> c_return_unique_ptr_vector_shared() {
-  auto retval = std::unique_ptr<std::vector<Shared>>(new std::vector<Shared>());
-  retval->push_back(Shared{1010});
-  retval->push_back(Shared{1011});
-  return retval;
+  auto vec = std::unique_ptr<std::vector<Shared>>(new std::vector<Shared>());
+  vec->push_back(Shared{1010});
+  vec->push_back(Shared{1011});
+  return vec;
+}
+
+std::unique_ptr<std::vector<C>> c_return_unique_ptr_vector_opaque() {
+  return std::unique_ptr<std::vector<C>>(new std::vector<C>());
+}
+
+const std::vector<uint8_t> &c_return_ref_vector(const C &c) {
+  return c.get_v();
+}
+
+rust::Vec<uint8_t> c_return_rust_vec() {
+  throw std::runtime_error("unimplemented");
+}
+
+const rust::Vec<uint8_t> &c_return_ref_rust_vec(const C &c) {
+  (void)c;
+  throw std::runtime_error("unimplemented");
 }
 
 void c_take_primitive(size_t n) {
@@ -163,18 +181,17 @@ void c_take_unique_ptr_vector_shared(std::unique_ptr<std::vector<Shared>> v) {
   }
 }
 
-void c_take_vec_u8(const ::rust::Vec<uint8_t> &v) {
-  auto cv = static_cast<std::vector<uint8_t>>(v);
-  uint8_t sum = std::accumulate(cv.begin(), cv.end(), 0);
-  if (sum == 200) {
+void c_take_ref_vector(const std::vector<uint8_t> &v) {
+  if (v.size() == 4) {
     cxx_test_suite_set_correct();
   }
 }
 
-void c_take_vec_shared(const ::rust::Vec<Shared> &v) {
-  auto cv = static_cast<std::vector<Shared>>(v);
+void c_take_rust_vec(rust::Vec<uint8_t> v) { c_take_ref_rust_vec(v); }
+
+void c_take_rust_vec_shared(rust::Vec<Shared> v) {
   uint32_t sum = 0;
-  for (auto i : cv) {
+  for (auto i : v) {
     sum += i.z;
   }
   if (sum == 2021) {
@@ -182,6 +199,13 @@ void c_take_vec_shared(const ::rust::Vec<Shared> &v) {
   }
 }
 
+void c_take_ref_rust_vec(const rust::Vec<uint8_t> &v) {
+  uint8_t sum = std::accumulate(v.begin(), v.end(), 0);
+  if (sum == 200) {
+    cxx_test_suite_set_correct();
+  }
+}
+
 void c_take_callback(rust::Fn<size_t(rust::String)> callback) {
   callback("2020");
 }
@@ -206,6 +230,15 @@ std::unique_ptr<std::string> c_try_return_unique_ptr_string() {
   return c_return_unique_ptr_string();
 }
 
+rust::Vec<uint8_t> c_try_return_rust_vec() {
+  throw std::runtime_error("unimplemented");
+}
+
+const rust::Vec<uint8_t> &c_try_return_ref_rust_vec(const C &c) {
+  (void)c;
+  throw std::runtime_error("unimplemented");
+}
+
 extern "C" C *cxx_test_suite_get_unique_ptr() noexcept {
   return std::unique_ptr<C>(new C{2020}).release();
 }
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
index 876e3c5..1d617ab 100644
--- a/tests/ffi/tests.h
+++ b/tests/ffi/tests.h
@@ -15,9 +15,11 @@ public:
   size_t set(size_t n);
   size_t get2() const;
   size_t set2(size_t n);
+  const std::vector<uint8_t> &get_v() const;
 
 private:
   size_t n;
+  std::vector<uint8_t> v;
 };
 
 size_t c_return_primitive();
@@ -32,6 +34,10 @@ std::unique_ptr<std::string> c_return_unique_ptr_string();
 std::unique_ptr<std::vector<uint8_t>> c_return_unique_ptr_vector_u8();
 std::unique_ptr<std::vector<double>> c_return_unique_ptr_vector_f64();
 std::unique_ptr<std::vector<Shared>> c_return_unique_ptr_vector_shared();
+std::unique_ptr<std::vector<C>> c_return_unique_ptr_vector_opaque();
+const std::vector<uint8_t> &c_return_ref_vector(const C &c);
+rust::Vec<uint8_t> c_return_rust_vec();
+const rust::Vec<uint8_t> &c_return_ref_rust_vec(const C &c);
 
 void c_take_primitive(size_t n);
 void c_take_shared(Shared shared);
@@ -46,8 +52,10 @@ void c_take_unique_ptr_string(std::unique_ptr<std::string> s);
 void c_take_unique_ptr_vector_u8(std::unique_ptr<std::vector<uint8_t>> v);
 void c_take_unique_ptr_vector_f64(std::unique_ptr<std::vector<double>> v);
 void c_take_unique_ptr_vector_shared(std::unique_ptr<std::vector<Shared>> v);
-void c_take_vec_u8(const ::rust::Vec<uint8_t> &v);
-void c_take_vec_shared(const ::rust::Vec<Shared> &v);
+void c_take_ref_vector(const std::vector<uint8_t> &v);
+void c_take_rust_vec(rust::Vec<uint8_t> v);
+void c_take_rust_vec_shared(rust::Vec<Shared> v);
+void c_take_ref_rust_vec(const rust::Vec<uint8_t> &v);
 void c_take_callback(rust::Fn<size_t(rust::String)> callback);
 
 void c_try_return_void();
@@ -59,5 +67,7 @@ rust::Str c_try_return_str(rust::Str);
 rust::Slice<uint8_t> c_try_return_sliceu8(rust::Slice<uint8_t>);
 rust::String c_try_return_rust_string();
 std::unique_ptr<std::string> c_try_return_unique_ptr_string();
+rust::Vec<uint8_t> c_try_return_rust_vec();
+const rust::Vec<uint8_t> &c_try_return_ref_rust_vec(const C &c);
 
 } // namespace tests
diff --git a/tests/test.rs b/tests/test.rs
index b33c675..07c23bd 100644
--- a/tests/test.rs
+++ b/tests/test.rs
@@ -32,44 +32,22 @@ fn test_c_return() {
     assert_eq!(b"2020\0", ffi::c_return_sliceu8(&shared));
     assert_eq!("2020", ffi::c_return_rust_string());
     assert_eq!("2020", ffi::c_return_unique_ptr_string().to_str().unwrap());
-    assert_eq!(
-        4,
-        ffi::c_return_unique_ptr_vector_u8()
-            .as_ref()
-            .unwrap()
-            .size()
-    );
+    assert_eq!(4, ffi::c_return_unique_ptr_vector_u8().len());
     assert_eq!(
         200_u8,
-        ffi::c_return_unique_ptr_vector_u8()
-            .as_ref()
-            .unwrap()
-            .into_iter()
-            .sum()
+        ffi::c_return_unique_ptr_vector_u8().into_iter().sum(),
     );
     assert_eq!(
         200.5_f64,
-        ffi::c_return_unique_ptr_vector_f64()
-            .as_ref()
-            .unwrap()
-            .into_iter()
-            .sum()
-    );
-    assert_eq!(
-        2,
-        ffi::c_return_unique_ptr_vector_shared()
-            .as_ref()
-            .unwrap()
-            .size()
+        ffi::c_return_unique_ptr_vector_f64().into_iter().sum(),
     );
+    assert_eq!(2, ffi::c_return_unique_ptr_vector_shared().len());
     assert_eq!(
         2021_usize,
         ffi::c_return_unique_ptr_vector_shared()
-            .as_ref()
-            .unwrap()
             .into_iter()
             .map(|o| o.z)
-            .sum()
+            .sum(),
     );
 }
 
@@ -113,11 +91,15 @@ fn test_c_take() {
     check!(ffi::c_take_unique_ptr_vector_shared(
         ffi::c_return_unique_ptr_vector_shared()
     ));
-    check!(ffi::c_take_vec_u8(&[86_u8, 75_u8, 30_u8, 9_u8].to_vec()));
-    check!(ffi::c_take_vec_shared(&vec![
+    check!(ffi::c_take_ref_vector(&ffi::c_return_unique_ptr_vector_u8()));
+    check!(ffi::c_take_rust_vec([86_u8, 75_u8, 30_u8, 9_u8].to_vec()));
+    check!(ffi::c_take_rust_vec_shared(vec![
         ffi::Shared { z: 1010 },
         ffi::Shared { z: 1011 }
     ]));
+    check!(ffi::c_take_ref_rust_vec(
+        &[86_u8, 75_u8, 30_u8, 9_u8].to_vec()
+    ));
 }
 
 #[test]

